UNIT Scrapbook;

{ this unit will read a scrapbook file into a set of acta topics }
{ for use with Acta 2.0 or higher								}

INTERFACE

	USES
		Globals;

	FUNCTION a_ScrapBook (add_topic_Ptr : ProcPtr;
									att : Topic_Attributes;
									ResRefNum : Integer;
									Refnum : Integer) : OsErr;

IMPLEMENTATION

  { ------------------------------------------------------------------------ }

	FUNCTION a_ScrapBook;

		CONST
			ActaTextTopic = 1;
			ActaPictTopic = 2;
			TopicLevel1 = 1;
			TopicLevel2 = 2;

		VAR
			ResHandle : Handle;
			TempPtr : Ptr;
			anErr : OSErr;
			ErrorString : Str255;
			RError : Integer;
			AppResNumber : Integer;
			ResCount : Integer;
			Size : LongInt;
			TType : OSType;
			i, j, k : Integer;


  { ------------------------------------------------------------------------ }

   { Acta Internal procedure for adding a topic to the current active window	}
   { This procedure was written in C, so arguments must be put on the stack 	}
   { in the reverse order of Dave's documentation 								  	}
   { This procedure is really linked to an ASM glue routine which pulls the    	}
   { pointer to the add_topic procedure off the stack and jumps to it.		 	}
   { and pulls the arguments off the stack before returning as well				}

		PROCEDURE add_topic (empty : Ptr;
										att : Topic_Attributes;
										level : Integer;
										size : LongInt;
										text : Ptr;
										add_topic_Ptr : ProcPtr);
		external;

  { ------------------------------------------------------------------------ }

		PROCEDURE Init;

	{ initialize a_Scrapbook	}

			VAR
				Watch : CursHandle;

		BEGIN

			Watch := GetCursor(WatchCursor);
	  { change cursor to watch while conversion is in progress }
			SetCursor(Watch^^);

	   { save away the current resource file }
			AppResNumber := CurResFile;

	  { Read from the input file }
			UseResFile(ResRefNum);

	  { start out with the text blocks }
			ATT.bType := ActaTextTopic;
			TType := 'TEXT';

		END; { Init }

	BEGIN { a_Scrapbook	}

		Init;		{ Initialize }

		FOR j := 1 TO 2 DO
			BEGIN

		{ if the current output type is text then count the TEXT resource,	}
		{  else count the number of picture resources 							}
				ResCount := CountResources(TType);
				RError := ResError;

				IF RError = noErr THEN
					BEGIN

			{ loop through all the resources of the current type }
						FOR i := 1 TO ResCount DO
							BEGIN
								ResHandle := GetIndResource(TType, i);
								RError := ResError;
				{ convert only those resources actually in the scrapbook file	}
								IF (RError = noerr) AND (HomeResFile(ResHandle) = ResRefNum) THEN
									BEGIN
										Hlock(ResHandle);
										Size := Longint(GetHandleSize(ResHandle));
										add_topic(NIL, ATT, TopicLevel2, Size, ResHandle^, add_topic_ptr);
										HUnLock(ResHandle);
									END; { If (RError = ...	}
								ReleaseResource(ResHandle);
							END; { For (rescount)	}

					END; { RError	}
				ATT.bType := ActaPictTopic;
				TType := 'PICT';

			END; { for (1 to 2) }

	{ Use the application resource fork }
		UseResFile(AppResNumber);
		InitCursor;				{ initialize cursor }

	{ somewhat simplistic error reporting }
		a_ScrapBook := RError;

	END; { a_ScrapBook	}

END. { ScrapBook	}