
UNIT initprogram;

INTERFACE

	USES
		Globals, Misc;

	PROCEDURE initall;

IMPLEMENTATION

	PROCEDURE SetUpMenus;

		VAR
			i : INTEGER;

	BEGIN
		InitMenus; { initialize Menu Manager }
		myMenus[applemenu] := GetMenu(appleMenu);
		AddResMenu(myMenus[applemenu], 'DRVR'); { desk accessories }
		myMenus[filemenu] := GetMenu(fileMenu);
		myMenus[editMenu] := GetMenu(editMenu);
		myMenus[baudMenu] := GetMenu(baudMenu);
		myMenus[parityMenu] := GetMenu(parityMenu);
		myMenus[bitsMenu] := GetMenu(bitsMenu);

		FOR i := applemenu TO lastMenu DO
			InsertMenu(myMenus[i], 0);
		DrawMenuBar;
	END; { of SetUpMenus }

{---------------------- set up serial port parameters ------------------------}

	PROCEDURE Init_serial;

		VAR
			errI : INTEGER;
			Hand : SerShk;

	BEGIN

	{ Pointers to buffers need to be set up - we are setting up for 2k and overriding 64 byte default }

		inBuffPtrA := NewPtr(inBuffLength);
		filterBuffPtrA := NewPtr(1);
		inBuffPtrB := NewPtr(inBuffLength);
		filterBuffPtrB := NewPtr(1);

		errI := RAMSDOpen(sPortA);		{ open modem port - sPortA is already defined }
		IF errI <> noErr THEN
			doMessage('Cannot open Ram serial driver Real A', 'Try turning off Appletalk in Chooser', '', '');

		errI := RAMSDOpen(sPortB);		{ open printer port - sPortB is already defined }
		IF errI <> noErr THEN
			doMessage('Cannot open Ram serial driver Real B', 'Try turning off AppleTalk in Chooser', '', '');

		inRefNumA := AinRefNum;			{driver reference number = -6}
		outRefNumA := AoutRefNum;		{driver reference number = -7}

		inRefNumB := BinRefNum;			{driver reference number = -8}
		outRefNumB := BoutRefNum;		{driver reference number = -9}

   {set baud rate, parity, etc. for both in and out}

		baud := 94;			   {1200}
		parity := 0;	   		   {none}
		dataBits := 3072;	   {8}
		stopBits := 16384;      {1}
		serConfig := baud + parity + dataBits + stopBits;

		errI := SerReset(inRefNumA, serConfig);		{ set modem input }
		errI := SerReset(outRefNumA, serConfig);	{ set modem output }
		errI := SerReset(inRefNumB, serConfig);		{ set printer input }
		errI := SerReset(outRefNumB, serConfig);		{ set modem output }

		{ set handshaking of ports for xon/xoff }

		WITH Hand DO
			BEGIN
				FXON := 0;
				FCTS := 0;
				XON := CHAR(XONCHAR);
				XOFF := CHAR(XOFFCHAR);
				ERRS := 0;
				EVTS := 0;
				FINX := 1;
			END;

		ErrI := SerHShake(inRefNumA, Hand);
		ErrI := SerHShake(inRefNumB, Hand);

   {set buffer}

		errI := SerSetBuf(inRefNumA, inBuffPtrA, inBuffLength);
		errI := SerSetBuf(inRefNumB, inBuffPtrB, inBuffLength);

		{ initially set I/O ports to the modem ports }

		inRefNum := inRefNumA;
		outRefNum := outRefNumB;
	END;  {Init_serial}

	PROCEDURE initall;
		VAR
			err : integer;
	BEGIN
		MoreMasters;			   {create 64 more master pointers - for future}
		MoreMasters;
		MaxApplZone;
		InitGraf(@thePort);
		InitFonts;
		FlushEvents(everyEvent, 0);
		InitWindows;
		SetUpMenus;
		init_serial;
		TEInit;
		InitDialogs(NIL);
		HideAll;
		Urgn := newRgn;
		SetCursor(arrow);
		SetRect(dragRect, 4, 24, 508, 338);
		doneFlag := FALSE;
		portA := true;
		row := 1;
		oneCount := 1;
		windowlines := 9;
		column := 1;
		numWindows := 0;
	END;
END.