{Set  RUN OPTIONS to use the resource file  Prototyper_Sample.RSRC    }
{RMaker file to use is Prototyper_Sample.R    }
{The Project should have the following files in it:     }
{     MacPasLib                  LSP This is the Pascal library file}
{     MacTraps                   LSP This is for Macintosh routines to be called}
{     ROM85                      LSP This is necessary if you use any Lists}
{     ROM85Lib                   LSP This is necessary if you use any Lists}
{     ListManager                LSP This is necessary if you use any Lists}
{     About_Dialog       Modal Dialog}
{     Sample_Window       Window}
{     InitTheMenus.Pas       This initializes the Menus.}
{    HandleTheMenus         Handle the menu selections.}
{   Prototyper_Sample.Pas    Main program}
Program  Prototyper_Sample;
{Program name:Prototyper_Sample.Pas   }
{Function:  This is the main module for this program.  }
{History: 6/13/88 Original by Prototyper.   }
{                       }
uses
  About_Dialog
  ,Sample_Window
  ,InitTheMenus
  ,HandleTheMenus
  ;
  var                                   {Main variables}
    myEvent:EventRecord;                {Event record for all events}
    doneFlag:boolean;                   {Exit program flag}
    code:integer;                       {Determine event type}
    whichWindow:WindowPtr;              {See which window for event}
    tempRect:Rect;                      {Rect for dragging}
    mResult:longint;                    {Menu list and item selected values}
    theMenu,theItem:integer;            {Menu list and item selected}
    chCode : integer;                   {Key code}
    ch : char;                          {Key pressed in Ascii}
    theInput:TEHandle;                  {Used in text edit selections}
 
  begin                                 {Start of main body}
 
    MoreMasters;                        {This reserves space for more handles}
    InitGraf(@thePort);                 {Quickdraw Init}
    InitFonts;                          {Font manager init}
    InitWindows;                        {Window manager init}
    InitMenus;                          {Menu manager init}
    TEInit;                             {Text edit init}
    InitDialogs(nil);                   {Dialog manager}
      
    FlushEvents(everyEvent, 0);         {Clear out all events}
    InitCursor;                         {Make an arrow cursor}
      
    doneFlag:=FALSE;                    {Do not exit program yet}
      
    Init_My_Menus;                      {Initialize menu bar}
      
    theInput:=nil;                      {Init to no text edit selection active}
    Init_Sample_Window;                 {Initialize the window routines}
    Open_Sample_Window;                 {Open the window routines at program start}
 
    repeat                              {Start of main event loop}
      if (theInput <> nil) then         {See if a TE is active}
        TEIdle(theInput);               {Blink the cursor if everything is ok}
      SystemTask;                       {For support of desk accessories}
        
 
      if GetNextEvent(everyEvent, myEvent) then {If event then...}
        begin                           {Start handling the event}
        code := FindWindow(myEvent.where, whichWindow); {Get which window the event happened in}
 
 
        case myEvent.what of            {Decide type of event}
          
          MouseDown :                   {Mouse button pressed}
            begin                       {Handle the pressed button}
              if (code = inMenuBar) then {See if a menu selection}
                begin                   {Get the menu selection and handle it}
                mResult := MenuSelect(myEvent.Where); {Do menu selection}
                theMenu := HiWord(mResult); {Get the menu list number}
                theItem := LoWord(mResult); {Get the menu list item number}
                Handle_My_Menu(doneFlag,theMenu,theItem,theInput); {Handle the menu}
                end;                    {End of inMenuBar}
 
              if (code = InDrag) then   {See if in a window drag area}
                begin                   {Do dragging the window}
                tempRect:= screenbits.bounds; {Get screen area,  l,t,r,b, drag area}
                SetRect(tempRect,tempRect.Left+10,tempRect.Top+25,tempRect.Right-10,tempRect.Bottom-10); {}
                DragWindow(whichWindow, myEvent.where, tempRect); {Drag the window}
                end;                    {End of InDrag}
 
              if (code = inGrow) then   {In a grow area of the window}
                begin                   {Handle the growing}
                tempRect:= whichWindow^.portRect;  {Get the window size and position}
                tempRect.Right := tempRect.Right - tempRect.Left + 1; {Adjust to local}
                tempRect.left := tempRect.Right - 18; {Do for width of right edge}
                tempRect.Bottom := tempRect.Bottom - tempRect.Top + 1; {Get window height}
                tempRect.top := 0;      {Do for height of the window}
                EraseRect(tempRect);    {Erase the old right edge}
                tempRect:= whichWindow^.portRect;  {Get the window size and position}
                tempRect.Right := tempRect.Right - tempRect.Left + 1; {Adjust to local}
                tempRect.left := 0;     {Do for width of the window}
                tempRect.Bottom := tempRect.Bottom - tempRect.Top + 1; {Get window height}
                tempRect.top := tempRect.Bottom - 18; {Do for height of the edge}
                EraseRect(tempRect);    {Erase the old bottom edge}
                SetRect(tempRect, 20, 20, 1000, 1000);  {Min Horz size, Min Vert size, Max Horz size, Max Vert size}
                mResult := GrowWindow(whichWindow, myEvent.where, tempRect); {Grow it}
                SizeWindow(whichWindow, LoWord(mResult), HiWord(mResult), TRUE); {Resize to result}
                DrawGrowIcon(whichWindow); {Draw the grow Icon again}
                end;                    {End of doing the growing}
 
              if (code = inGoAway) then {See if in a window goaway area}
                begin                   {Handle the goaway button}
                If TrackGoAway(whichWindow,myEvent.where) then {See if mouse released in GoAway box}
                  begin                 {Handle the GoAway}
                  Close_Sample_Window(whichWindow,theInput); {Close this window}
                  end;                  {End of TrackGoAway}
                end;                    {End of InGoAway}
 
              if (code = inContent) then {See if in a window}
                begin                   {Handle the hit inside a window}
                if (whichWindow <> FrontWindow) then {See if already selected or not, in front if selected}
                  SelectWindow(whichWindow) {Select this window to make it active}
                else                    {If already in front the already selected}
                  begin                 {Handle the button in the content}
                  SetPort(whichWindow); {Get ready to draw in this window}
                  Do_Sample_Window ( myEvent,theInput ); {Handle this window}
                  end;                  {End of else}
                end;                    {End of inContent}
 
              if (code = inSysWindow) then {See if a DA selection}
                SystemClick(myEvent, whichWindow); {Let other programs in}
 
            end;                        {End of MouseDown}
 
          KeyDown,AutoKey:              {Handle key inputs}
            begin                       {Get the key and handle it}
              with myevent do           {Check for menu command keys}
                begin                   {}
                  chCode := BitAnd(message, CharCodeMask); {Get character}
                  ch := CHR(chCode);    {Change to ASCII}
                  if (Odd(modifiers div CmdKey)) then {See if Command key is down}
                    begin               {}
                    mResult := MenuKey(ch); {See if menu selection}
                    theMenu := HiWord(mResult); {Get the menu list number}
                    theItem := LoWord(mResult); {Get the menu item number}
                    if (theMenu <> 0) then {See if a list was selected}
                    Handle_My_Menu(doneFlag,theMenu,theItem,theInput); {Do the menu selection}
                    if ((ch = 'x') or (ch = 'X')) and (theInput <> nil) then {}
                      TECut(theInput);  {Handle a Cut in a TE area}
                    if ((ch = 'c') or (ch = 'C')) and (theInput <> nil) then {}
                      TECopy(theInput); {Handle a Copy in a TE area}
                    if ((ch = 'v') or (ch = 'V')) and (theInput <> nil) then {}
                      TEPaste(theInput); {Handle a Paste in a TE area}
                    end                 {}
                  else if (theInput <> nil) then {}
                    TEKey(ch,theInput); {}
                end;                    {End for with}
            end;                        {End for KeyDown,AutoKey}
 
          UpDateEvt :                   {Update event for a window}
            begin                       {Handle the update}
              whichWindow := WindowPtr(myEvent.message); {Get the window the update is for}
              BeginUpdate(whichWindow); {Set the clipping to the update area}
              Update_Sample_Window ( whichWindow ); {Update this window}
              EndUpdate(whichWindow);   {Return to normal clipping area}
            end;                        {End of UpDateEvt}
 
          DiskEvt :                     {Disk inserted event}
            begin                       {Handle a disk event}
            {Ck for disk event}         {?? ADD CALL TO HANDLE A DISK INSERTED}
            end;                        {End of DiskEvt}
            
          ActivateEvt :                 {Window activated event}
            begin                       {Handle the activation}
              whichWindow := WindowPtr(myevent.message); {Get the window to be activated}
              if odd(myEvent.modifiers) then {Make sure it is Activate and not DeActivate}
              SelectWindow(whichWindow); {Activate the window by selecting it}
            end;                        {End of ActivateEvt}
 
          otherwise                     {Used for debugging, to see what other events are coming in}
            begin                       {}
              {}                        {?? ADDED FOR DEBUGGING, CATCHING OTHER EVENTS}
            end;                        {End of otherwise}
 
        end;                            {End of case}
 
        end;                            {end of GetNextEvent}
    until doneFlag;                     {End of the event loop}
 
end.                                    {End of the program}
