unit  Sample_Window;

{File name: Sample_Window.Pas}
{Function: Handle a Window}
{History: 6/13/88 Original by Prototyper.   }

interface


  {Initialize us so all our routines can be activated}
  procedure Init_Sample_Window;

  {Close our window}
  procedure Close_Sample_Window(whichWindow:WindowPtr; var theInput:TEHandle);

  {Open our window and draw everything}
  procedure Open_Sample_Window;

  {Update our window, someone uncovered a part of us}
  procedure Update_Sample_Window(whichWindow:WindowPtr);

  {Handle action to our window, like controls}
  procedure Do_Sample_Window(myEvent:EventRecord; var theInput:TEHandle);

implementation

  const
    I_Buttonx1 = 4;                     {Button ID}
    I_Checkbox1 = 6;                    {Checkbox ID}
    I_Checkbox2 = 17;                   {Checkbox ID}
    I_Radio1 = 7;                       {Radio ID}
    I_Radio2 = 18;                      {Radio ID}
    I_Edit_Text = 3;                    {Edit text ID}
    I_Scroll_bar = 5;                   {Scroll bar ID}
  var
    MyWindow:WindowPtr;                 {Window pointer}
    tempRect : Rect;                    {Temporary rectangle}
    Index : Integer;                    {For looping}
    CtrlHandle : controlhandle;         {Control handle}
    sTemp : Str255;                     {Get text entered, temp holding}
    R1Control:array[1..2] of ControlHandle; { Radio button handles for group 1}
    TE_I_Edit_Text: TEHandle;           {Text Edit field handle}
 
{=================================}
 
  {Initialize us so all our routines can be activated}
  procedure Init_Sample_Window;
 
  begin                                 {Start of Window initialize routine}
    MyWindow:=nil;                      {Make sure other routines know we are not valid yet}
  end;                                  {End of procedure}

{=================================}
 
  {Close our window}
  procedure Close_Sample_Window;
 
  begin                                 {Start of Window close routine}
    if (MyWindow <> nil) and (MyWindow = whichWindow) then {Close if this is us}
      begin
      if (theInput = TE_I_Edit_Text) then {See if this Text Edit field handle}
      theInput:= nil;                   {Clear the handle used}
      DisposeWindow(MyWindow);          {Clear window and controls}
      MyWindow:=nil;                    {Make sure other routines know we are open}
      end;                              {End for if (MyWindow<>nil)}
  end;                                  {End of procedure}

{=================================}
 
  {Update our window, someone uncovered a part of us}
  procedure UpDate_Sample_Window;
  var
    SavePort : WindowPtr;               {Place to save the last port}
    Pic_Handle: PicHandle;              {Picture handle for picture loaded and displayed}
    sTemp:Str255;                       {Temporary string}

  begin                                 {Start of Window update routine}
    if (MyWindow <> nil) and (MyWindow = whichWindow) then {Handle an open when already opened}
      begin
      GetPort(SavePort);                {Save the current port}
      SetPort(MyWindow);                {Set the port to my window}
      {Draw the Picture, Picture}
      Pic_Handle := GetPicture(9 );     {Get Picture into memory}
      SetRect(tempRect, 188,141,247,218); {left,top,right,bottom}
      if (Pic_Handle <> nil) then       {Only use handle if it is valid}
        DrawPicture ( Pic_Handle , tempRect ); {Draw this picture}
      
      TextFont(systemFont);             {Set the font to draw in}
      {Draw a string of text, Static Text }
      SetRect(tempRect, 252,146,330,184);
      sTemp :='Read MacTutor!';
      TextBox(Pointer(ord(@sTemp) + 1), length(sTemp), tempRect, teJustLeft);
      TextFont(applFont);               {Set the default application font}
      
      {Update a TE box, Edit Text }
      SetRect(TempRect,46,27,294,129);  {left,top,right,bottom}
      InsetRect(TempRect,-2,-2);        {Surround the TE area}
      FrameRect(TempRect);              {Frame this TE area}
      if (TE_I_Edit_Text <> nil) then   {Only update if TE area is valid}
        TEUpdate(TempRect,TE_I_Edit_Text); {Update the TE area}
      
      DrawControls(MyWindow);           {Draw all the controls}
      DrawGrowIcon(MyWindow);           {Draw the Grow box}
      SetPort(SavePort);                {Restore the old port}
    end;                                {End for if (MyWindow<>nil)}
  end;                                  {End of procedure}

{=================================}
 
  {Open our window and draw everything}
  procedure Open_Sample_Window;
  var
    Index : Integer;                    {For looping}
    dataBounds : Rect;                  {For making lists}
    cSize : Point;                      {For making lists}

  begin                                 {Start of Window open routine}
 
    if (MyWindow = nil) then            {Handle an open when already opened}
      begin
      MyWindow:= GetNewWindow(1,nil, Pointer(-1)); {Get the window from the resource file}
      SelectWindow(MyWindow);           {Bring our window to the front}
      SetPort(MyWindow);                {Prepare to write into our window}
      
      { Make a button, Button }
      CtrlHandle := GetNewControl(I_Buttonx1,MyWindow); {Make a new button}
      
      { Make a checkbox, Checkbox1 }
      CtrlHandle := GetNewControl(I_Checkbox1,MyWindow); {Make a new checkbox}
      
      { Make a checkbox, Checkbox2 }
      CtrlHandle := GetNewControl(I_Checkbox2,MyWindow); {Make a new checkbox}
      
      { Make a radio button, Radio1 }
      R1Control[1] := GetNewControl ( I_Radio1 , MyWindow ); {Make a new radio button}
      
      { Make a radio button, Radio2 }
      R1Control[2] := GetNewControl ( I_Radio2 , MyWindow ); {Make a new radio button}
      
      { Make a scroll bar, Scroll bar }
      CtrlHandle := GetNewControl(I_Scroll_bar,MyWindow); {Make a new scrollbar}
      
      {Open a TE box, Edit Text }
      SetRect(TempRect,46,27,294,129);  {left,top,right,bottom}
      InsetRect(TempRect,-2,-2);        {Surround the TE area}
      FrameRect(TempRect);              {Frame this TE area}
      InsetRect(TempRect,2,2);          {Restore the original size}
      TE_I_Edit_Text:= TENew(TempRect,TempRect); {Create the TE area}
      HLock(Handle(TE_I_Edit_Text));    {Lock the handle before using it}
      TE_I_Edit_Text^^.txFont := geneva; {Font to use for the TE area}
      TE_I_Edit_Text^^.fontAscent := 12; {Font ascent}
      TE_I_Edit_Text^^.lineHeight := 12 + 3 + 1; {Font ascent + descent + leading}
      HUnLock(Handle(TE_I_Edit_Text));  {UnLock the handle when done}
      sTemp:= 'Edit Text';
      {Default text string}
      TESetText(Pointer(Ord4(@sTemp)+1),length(sTemp),TE_I_Edit_Text); {Place default text in the TE area}
      TEActivate(TE_I_Edit_Text);       {Make the TE area active}
      TEUpdate(TempRect,TE_I_Edit_Text);
      TextFont(applFont);               {Set the default application font}
      
      UpDate_Sample_Window(MyWindow);   {Do an update to draw rest of items}
      
      end                               {End for if (MyWindow<>nil)}
    else
      SelectWindow(MyWindow);           {Already open, so show it}
    
  end;                                  {End of procedure}

{=================================}
 
  {Handle action to our window, like controls}
  procedure Do_Sample_Window;
  var
    RefCon:integer;                     {RefCon for controls}
    code:integer;                       {Location of event in window or controls}
    theValue:integer;                   {Current value of a control}
    whichWindow:WindowPtr;              {Window pointer where event happened}
    myPt:Point;                         {Point where event happened}
    theControl:ControlHandle;           {Handle for a control}

  Procedure Do_A_Button;                {Handle a button being pressed}
  begin
    HiliteControl(theControl, 10);      {Darken the button}
    RefCon := GetCRefCon(theControl);   {get control refcon}
    
    case RefCon of                      {Select correct button}
            I_Buttonx1:                 {Button, button}
              begin                     {start for this button}
                {??? HANDLE THE BUTTON BEING PRESSED HERE}
              end;                      {end for this button}
          
          otherwise                     {allow other buttons, trap for debug}
              begin                     {start}
              end;                      {end of otherwise}
    end;                                {end of case}
    
    HiliteControl(theControl, 0);       {Lighten the button}
  end;                                  {Handle a button being pressed}


  Procedure Do_A_Checkbox;              {Handle a checkbox being pressed}
  var
    Index:integer;                      {Index used for radios}

  procedure Clear1RadioGroup;           {Routine to clear radios in group 1}
  var
    Index:integer;                      {Index used for radios}
  begin                                 {Start of the clear routine}
    for Index := 1 to 2 do              {Step thru all radios}
      SetCtlValue(R1Control[Index],0);  {Set this radio to zero}
  end;                                  {End of the clear routine}

  begin                                 {Handle a checkbox being pressed}
    RefCon := GetCRefCon(theControl);   {get control refcon}
    theValue := GetCtlValue(theControl); {Get current value}
    theValue := (theValue + 1) mod 2;   {Change value}
    
    case RefCon of                      {Select correct button}
            I_Checkbox1:                {Checkbox1, checkbox}
              begin                     {start for this button}
                {??? HANDLE THE CHECKBOX BEING PRESSED HERE}
                SetCtlValue(theControl, theValue); {Set checkbox to new value}
              end;                      {end for this checkbox}
          
            I_Checkbox2:                {Checkbox2, checkbox}
              begin                     {start for this button}
                {??? HANDLE THE CHECKBOX BEING PRESSED HERE}
                SetCtlValue(theControl, theValue); {Set checkbox to new value}
              end;                      {end for this checkbox}
          
            I_Radio1:                   {Radio1 , radio button}
               begin                    {start for this radio button}
                {??? HANDLE THE RADIO BEING SELECTED HERE}
                Clear1RadioGroup;       {Clear all Radio values in this group}
                SetCtlValue(theControl, 1); {Select this Radio}
              end;                      {end for this radio button}
          
            I_Radio2:                   {Radio2 , radio button}
               begin                    {start for this radio button}
                {??? HANDLE THE RADIO BEING SELECTED HERE}
                Clear1RadioGroup;       {Clear all Radio values in this group}
                SetCtlValue(theControl, 1); {Select this Radio}
              end;                      {end for this radio button}
          
          otherwise                     {allow other checkboxes and radios, trap for debug}
              begin                     {start}
              end;                      {end of otherwise}
    end;                                {end of case}
    
  end;                                  {Handle a checkbox being pressed}


  Procedure Do_A_ScrollBar(code:integer); {Handle a ScrollBar being pressed}

    procedure HandleWScrollBar (code, Start, Stop, Increment, LIncrement : integer;
    theControl : ControlHandle);
    var
      theValue : integer;               {Value of the scrollbar}
      myPt : Point;                     {Returned point from track}
  
    begin
      theValue := GetCtlValue(theControl); {Get current state}
      
      if (code = inUpButton) then       {See if in the up/left arrow}
        begin
        theValue := theValue - Increment; {Subtract the single decrement}
        if (theValue < Start) then      {Check for boundary conditions}
          theValue := Start;            {Bump at the start value}
        end;
      
      if (code = inDownButton) then     {See if in the down/right arrow}
        begin
        theValue := theValue + Increment; {Add the single increment}
        if (theValue > Stop) then       {Check for boundary conditions}
          theValue := Stop;             {Bump at the stop value}
        end;
      
      if (code = inPageUp) then         {See if in the up/left grey area}
        begin
        theValue := theValue - LIncrement; {Subtract the page increment}
        if (theValue < Start) then      {Check for boundary conditions}
          theValue := Start;            {Bump at the Start value}
        end;
      
      if (code = inPageDown) then       {See if in the down/right grey area}
        begin
        theValue := theValue + LIncrement; {Add the page increment}
        if (theValue > Stop) then       {Check for boundary conditions}
          theValue := Stop;             {Bump at the Stop value}
        end;
      
      if (code = inThumb) then          {See if in the drag box area}
        begin
        code := TrackControl(theControl, myPt, nil); {Let the OS drag it around}
        theValue := GetCtlValue(theControl); {Get current state}
        end;
      
      SetCtlValue(theControl, theValue); {Set new state}
    end;                                {End of handle scroll bar}
  

  begin                                 {Handle a ScrollBar being pressed}
    RefCon := GetCRefCon(theControl);   {get control refcon}
    
    case RefCon of                      {Select correct scrollbar}
            I_Scroll_bar:               {Scroll bar', scroll bar}
              begin                     {start for this scroll bar}
                HandleWScrollBar(code,1,10,1,10,theControl); {code,Min,Max,Inc,PageInc,handle}
              end;                      {end for this scroll bar}
          
          otherwise                     {allow other scrollbars (lists), trap for debug}
              begin                     {start}
              end;                      {end of otherwise}
    end;                                {end of case}
  end;                                  {Handle a ScrollBar being pressed}


  begin                                 {Start of Window handler}
    if (MyWindow <> nil) then           {Handle only when the window is valid}
      begin
      code := FindWindow(myEvent.where, whichWindow); {Get where in window and which window}
      
      if (myEvent.what = MouseDown) and (MyWindow = whichWindow) then {}
        begin                           {}
        myPt := myEvent.where;          {Get mouse position}
        with MyWindow^.portBits.bounds do {Make it relative}
          begin
            myPt.h := myPt.h + left;
            myPt.v := myPt.v + top;
          end;
         
        
        SetRect(tempRect,46,27,294,129); {Position of the TE}
        if PtInRect(myPt,tempRect) then {Check for pressed in the TE  Edit Text }
          begin                         
          theInput:= TE_I_Edit_Text;    
          TEClick(myPt, FALSE, TE_I_Edit_Text); 
          end;                          
        
        
        SetRect(tempRect,188,141,247,218); {Position of the Picture}
        if PtInRect(myPt,tempRect) then {Check for pressed in the Picture  Picture }
          begin                         
          end;                          
        
         end;
       
      if (MyWindow = whichWindow) and (code = inContent) then {for our window}
        begin
        
        code := FindControl(myPt, whichWindow, theControl); {Get type of control}
        if (code <> 0) then             {Check type of control}
          code := TrackControl(theControl,myPt, nil); {Track the control}
        
        if code = inButton then
          Do_A_Button;                  {Do buttons}
        if code = inCheckBox then
          Do_A_Checkbox;                {Do checkboxes}
        if (code = inUpButton) or (code = inDownButton) or (code = inThumb) or  (code = inPageDown) or (code = inPageUp) then
          Do_A_ScrollBar(code);         {Do scrollbars}
        
        end;                            {End for if (MyWindow=whichWindow)}
      end;                              {End for if (MyWindow<>nil)}
  end;                                  {End of procedure}

{=================================}
 

end.                                    {End of unit}

