* File: PrGenDefs.inc   Definitions for calls to printer trap PrGeneral
*  1/11/88  Jay Lieske
*
* Information for GetRsl
*     This file contains definitions for calls to PrGeneral with iOpCode=4
*     (called gOpCode here) which is the GetRslData call.
*

* the GetRslData record is of length 128 bytes

      integer*1   GetRslDataRec(128)
      integer*2   gOpCode
      integer*2   gError
      integer*4   gReserved
      integer*2   iRgType
      integer*2   XRslRg(2)
      integer*2   YRslRg(2)
      integer*2   iRslRecCnt
      integer*2   rgRslRec(2,27)
                              ! defined as ARRAY[1..27] of TRslRec
      equivalence (GetRslDataRec(1), gOpCode)
      equivalence (GetRslDataRec(3), gError)
      equivalence (GetRslDataRec(5), gReserved)
      equivalence (GetRslDataRec(9), iRgType)
      equivalence (GetRslDataRec(11), XRslRg)
      equivalence (GetRslDataRec(15), YRslRg)
      equivalence (GetRslDataRec(19), iRslRecCnt)
      equivalence (GetRslDataRec(21), rgRslRec)

      integer*4 pGetRslData
C     parameter (gOpCode = 4)

* You must set the value of gOpCode
* in program. Get pointer to GetRslDataRec via: pGetRslData = TOOLBX(PTR,GetRslDataRec )
* and then CALL toolbx(PrGeneral, pGetRslData, xPrGeneral)

* end of data for GetRsl

* Information for SetRsl
*     This file contains definitions for calls to PrGeneral with iOpCode=5
*     (called pOpCode here) which is the SetRslData call.
*

* the SetRslData record is of length 16 bytes

      integer*1   SetRslRec(16)
      integer*2   pOpCode
      integer*2   pError
      integer*4   pReserved
      integer*4   hPrint
      integer*2   iXRsl
      integer*2   iYRsl

      equivalence (SetRslRec(1), pOpCode)
      equivalence (SetRslRec(3), pError)
      equivalence (SetRslRec(5), pReserved)
      equivalence (SetRslRec(9), hPrint)
      equivalence (SetRslRec(13), iXRsl)
      equivalence (SetRslRec(15), iYRsl)

      integer*4 pSetRsl
C     parameter (pOpCode = 5)

*  You must set the values of pOpCode = 5 and hPrint = handle to Print Record
* in program. Get pointer to SetRslRec via: pSetRsl = TOOLBX(PTR,SetRslRec)
* and then CALL toolbx(PrGeneral, pSetRsl, xPrGeneral)
* end of data forSetRsl
* end of file PrGenDefs.inc
