/*****************************************************
Pop-up Menu Example - Resources
*****************************************************/

#include "Types.r"
#include "PopMenuCDEF.r"

/* 1 = use color resources; 0 = don't */
#define	COLOR	1


/* include the CDEF */
data 'CDEF' (pmCDEFResID, "popMenu") {
	$$resource("PopMenuCDEF.CDEF", 'CDEF', 1)
};

/* our sample dialog */
resource 'DLOG' (128) {
	{40, 70, 170, 440},		/* 130 tall, 370 wide */
	dBoxProc,
	visible,
	noGoAway,
	0x0,
	128,
	""
};

/* the sample dialog's item list: 3 pop-up menu ctls */
resource 'DITL' (128) {
	{	/* array DITLarray: 4 elements */
		/* [1] */
		{10, 275, 30, 360},
		Button {
			enabled,
			"OK"
		},
		
		/* [2] */
		{40, 275, 60, 360},
		Button {
			enabled,
			"Deactivate"
		},
		
		/* [3] */
		{10, 10, 30, 270},
		Control {
			enabled,
			128
		},
		
		/* [4] */
		{40, 10, 60, 270},
		Control {
			enabled,
			129
		},
		
		/* [5] */
		{70, 10, 90, 270},
		Control {
			enabled,
			130
		},
		
		/* [6] */
		{90, 10, 125, 360},
		StaticText {
			disabled,
			"PopUp Menu Control CDEF example.  "
			"James Plamondon,  Abacus Concepts,  "
			"(415) 540-1949."
		}
	}
};

resource 'CNTL' (128) {
	{10, 10, 30, 270},	/* rect:  contrlRect		*/
	128,				/* value: menu rsrc ID 	*/
	visible,				/* vis:  standard		*/
	128,				/* max:  default menuID	*/
	2,					/* min:  default item #	*/
	popMenuProc 		/* ProcID:  3 			*/
		+ mCheck,		/* var: Check selection	*/
	0,					/* rfCon: for user's use	*/
	"Thanks To: "		/* title: standard		*/
};

resource 'MENU' (128) {
	128,
	textMenuProc,
	allEnabled,
	enabled,
	"Thanks To: ",
	{	/* 11 items */
		"Mark Williams",
			noIcon, noKey, noMark, plain;
		"Mark Bennet",
			noIcon, noKey, appleChar, plain;
		"Joseph Daniel",
			noIcon, noKey, noMark, plain;
		"Dr. Don Morrison",
			noIcon, noKey, noMark, plain;
		"Andrew Stone",
			noIcon, noKey, noMark, plain;
		"Eleanor Plamondon",
			noIcon, noKey, noMark, plain;
		"Bruce Wampler",
			noIcon, noKey, noMark, plain;
		"Patricia Guffey",
			noIcon, noKey, noMark, plain;
		"Greta Shaw",
			noIcon, noKey, noMark, plain;
		"Monty \"Montana-Unit\" Cole",
			noIcon, noKey, noMark, plain;
		"Dr. Bernard Moret",
			noIcon, noKey, noMark, plain
	}
};

resource 'CNTL' (129) {
	{40, 10, 60, 270},	/* rect:  contrlRect		*/
	129,				/* value: rsrc ID		*/
	visible,				/* vis:  standard		*/
	129,				/* max: default  menuID	*/
	2,					/* min:  default item #	*/
	popMenuProc 		/* ProcID: 3 			*/
		+ mRes			/* var: add res names	*/
		+ mCheck,		/* var: Check selection	*/
	'FONT',				/* rfCon: OSType		*/
	"Fonts: "			/* title: standard		*/
};

resource 'MENU' (129) {
	129,
	textMenuProc,
	allEnabled,
	enabled,
	"Fonts: ",
	{	/* 0 items */
	}
};

resource 'CNTL' (130) {
	{70, 10, 90, 270},	/* rect:  contrlRect		*/
	130,				/* value: rsrc ID 		*/
	visible,				/* vis:  standard		*/
	133,				/* max:  default menuID	*/
	1,					/* min: default  item #	*/
	popMenuProc		/* ProcID: 3			*/
		+ mCheck,		/* var: Check selection	*/
	
	0,					/* rfCon: for user's use	*/
	"Root: "				/* title: standard		*/
};

resource 'MENU' (130) {
	130,
	textMenuProc,
	allEnabled,
	enabled,
	"Root: ",
	{	/* 2 items */
		"Root Item1",
			noIcon, parent, "\0D131", plain;
		"Root Item2",
			noIcon, parent, "\0D132", plain
	}
};

resource 'MENU' (131) {
	131,
	textMenuProc,
	allEnabled,
	enabled,
	"",
	{	/* 2 items */
		"Sub-1 Item1",
			noIcon, noKey, noMark, plain;
		"Sub-1 Item2",
			noIcon, noKey, noMark, plain;
		"Sub-1 Item3",
			noIcon, parent, "\0D133", plain
	}
};

resource 'MENU' (132) {
	132,
	textMenuProc,
	allEnabled,
	enabled,
	"",
	{	/* 2 items */
		"Sub-2 Item1",
			noIcon, noKey, noMark, plain;
		"Sub-2 Item2",
			noIcon, noKey, noMark, plain;
		"Sub-2 Item3 (a very, very, very wide item)",
			noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (133) {
	133,
	textMenuProc,
	allEnabled,
	enabled,
	"",
	{	/* 2 items */
		"Sub-3 Item1",
			noIcon, noKey, noMark, plain;
		"Sub-3 Item2",
			noIcon, noKey, noMark, plain;
		"Sub-3 Item3",
			noIcon, noKey, noMark, plain
	}
};

#if	COLOR
resource 'mctb' (128) {
	{	/* array MCTBArray: 12 elements */
		/* [1] */
		128, 0,						/* menu 128, title	*/
		{	/* array: 4 elements */
			/* [1] */			
			0, 0, $FFFF,
			/* [2] */			
			0, 0, 0,
			/* [3] */
			0, $FFFF, 0,
			/* [4] */
			$FFFF, $FFFF, $FFFF
		},
		
		128, 1,						/* menu 128, item 1	*/
		{	/* array: 4 elements */
			/* [1] */			
			$FFFF, 0, 0,
			/* [2] */
			$0040, $FFFF, 0,
			/* [3] */
			0, 0, 0,
			/* [4] */
			0, 0, 0,
		},
		
		128, 2,					/* menu 128, item 2	*/
		{	/* array: 4 elements */
			/* [1] */			
			$FFFF, 0, 0,
			/* [2] */
			$0100, $8000, 0,
			/* [3] */
			0, 0, 0,
			/* [4] */
			0, 0, 0,
		},
		
		128, 3,					/* menu 128, item 3	*/
		{	/* array: 4 elements */
			/* [1] */			
			$FFFF, 0, 0,
			/* [2] */
			$0400, $6000, 0,
			/* [3] */
			0, 0, 0,	
			/* [4] */
			0, 0, 0,
		},
		
		128, 4,					/* menu 128, item 4	*/
		{	/* array: 4 elements */
			/* [1] */			
			$FFFF, 0, 0,
			/* [2] */
			$0800, $4000, 0,
			/* [3] */
			0, 0, 0,
			/* [4] */
			0, 0, 0,
		},
		
		128, 5,					/* menu 128, item 5	*/
		{	/* array: 4 elements */
			/* [1] */			
			$FFFF, 0, 0,
			/* [2] */
			$1000, $2000, 0,
			/* [3] */
			0, 0, 0,
			/* [4] */
			0, 0, 0,
		},
		
		128, 6,					/* menu 128, item 6	*/
		{	/* array: 4 elements */
			/* [1] */			
			$FFFF, 0, 0,
			/* [2] */
			$1800, $1800, 0,
			/* [3] */
			0, 0, 0,
			/* [4] */
			0, 0, 0,
		},
		
		128, 7,					/* menu 128, item 7	*/
		{	/* array: 4 elements */
			/* [1] */			
			$FFFF, 0, 0,
			/* [2] */
			$2000, $1000, 0,
			/* [3] */
			0, 0, 0,
			/* [4] */
			0, 0, 0,
		},
		
		128, 8,					/* menu 128, item 8	*/
		{	/* array: 4 elements */
			/* [1] */			
			$FFFF, 0, 0,
			/* [2] */
			$4000, $0400, 0,
			/* [3] */
			0, 0, 0,
			/* [4] */
			0, 0, 0,
		},
		
		128, 9,					/* menu 128, item 9	*/
		{	/* array: 4 elements */
			/* [1] */			
			$FFFF, 0, 0,
			/* [2] */
			$6000, $0200, 0,
			/* [3] */
			0, 0, 0,
			/* [4] */
			0, 0, 0,
		},
		
		128, 10,				/* menu 128, item 10 */
		{	/* array: 4 elements */
			/* [1] */			
			$FFFF, 0, 0,
			/* [2] */
			$8000, $0100, 0,
			/* [3] */
			0, 0, 0,
			/* [4] */
			0, 0, 0,
		},
		
		128, 11,					/* menu 128, item 11 */
		{	/* array: 4 elements */
			/* [1] */			
			$FFFF, 0, 0,
			/* [2] */
			$FFFF, $0040, 0,
			/* [3] */
			0, 0, 0,
			/* [4] */
			0, 0, 0,	
		}
	}
};

resource 'mctb' (129) {
	{	/* array MCTBArray: 1 elements */
		/* [1] */
		129, 0,
		{	/* array: 4 elements */
			/* [1] */
			0, $4000, $4000,
			/* [2] */			
			0, 0, 0,
			/* [3] */
			0, $4000, 0,
			/* [4] */
			$FFFF, $FFFF, $FFFF
		}
	}
};

resource 'mctb' (130) {
	{	/* array MCTBArray: 1 elements */
		/* [1] */
		130, 0,
		{	/* array: 4 elements */
			/* [1] */
			$0, $4000, $0,
			/* [2] */			
			0, 0, 0,
			/* [3] */
			0, $4000, 0,
			/* [4] */
			$4000, 0, $4000
		}
	}
};

resource 'mctb' (131) {
	{	/* array MCTBArray: 1 elements */
		/* [1] */
		131, 0,
		{	/* array: 4 elements */
			/* [1] */
			$8000, $8000, $2000,
			/* [2] */
			$0, $0, $0,
			/* [3] */
			$0, $0, $0,
			/* [4] */
			$2000, $2000, $8000
		}
	}
};

resource 'mctb' (132) {
	{	/* array MCTBArray: 1 elements */
		/* [1] */
		132, 0,
		{	/* array: 4 elements */
			/* [1] */
			$1000, $C000, $C000,
			/* [2] */			
			0, 0, 0,
			/* [3] */
			$4000, $6000, $FFFF,
			/* [4] */
			$C000, $1000, $1000
		}
	}
};

resource 'mctb' (133) {
	{	/* array MCTBArray: 1 elements */
		/* [1] */
		133, 0,
		{	/* array: 4 elements */
			/* [1] */
			$8000, $0, $0,
			/* [2] */			
			0, 0, 0,
			/* [3] */
			$4000, 0, $4000,
			/* [4] */
			$0, $8000, $0
		}
	}
};

resource 'dctb' (128) {
	0x0,
	0,
	{	/* array ColorSpec: 3 elements */
		/* [1] */
		wContentColor, $FFFF, $FFFF, $FFFF,
		/* [2] */
		wFrameColor, 0, 0, $FFFF,
		/* [3] */
		wHiliteColor, $2000, $FFFF, $2000
	}
};

data 'ictb' (128) {
	/* (000) 0000: */	$"0040 0018"
	/* (004) 0004: */	$"0040 0018"
	/* (008) 0008: */	$"0000 0000"
	/* (012) 000C: */	$"0000 0000"
	/* (016) 0010: */	$"0000 0000"
	/* (020) 0014: */	$"800F 0040"
	
	/* (024) 0018: */	$"0000 0000"
	/* (028) 001C: */	$"0000"
	/* (030) 001E: */	$"0003"
	/* (032) 0020: */	$"0000 0000 0000 0000"
	/* (040) 0028: */	$"0001 4000 FFFF 4000"
	/* (048) 0030: */	$"0002 0000 0000 0000"
	/* (056) 0038: */	$"0003 0000 0000 FFFF"
	
	/* (064) 0040: */	$"0054"
	/* (066) 0042: */	$"0200"
	/* (068) 0044: */	$"0009"
	/* (070) 0046: */	$"FFFF 0000 0000"
	/* (076) 004C: */	$"FFFF FFFF FFFF"
	/* (082) 0052: */	$"0001"
	
	/* (084) 0054: */	$"0647 656E 6576 61"
};
#endif	/* COLOR */

/* end of resource file */

