/*_______________________________

			MSmeta.h

	Source file for MSMeta.p
	20 Oct 87

  _____________________________*/
//#include "Mytools.p"

/*	___________	Menu Verb Codes	___________________*/

#define	_MVNORMAL	0
#define	_MVCHKTOG	1
#define	_MVTEXTOG	2
#define	_MVENABPR	3
#define	_MVNZEXRG	4
#define	_MVCMRGRS	5
#define	_MVENBSET	6
#define	_MVTTGSET	7
#define	_MVMENLIN	-128

/*	___________	Menu Flags	___________________*/

#define	_MFSYSLOD	0
#define	_MFERRTRM 	1 
#define	_MFEXPRNG	2
#define	_MFALOCTB	3
#define	_MFBLDTAB	4
#define	_MFSETXRG	5
#define	_MFSETPRE	6
#define	_MFSUBMEN	7
#define	_MFHASSTR	8
#define	_MFPRCPAR	9
#define	_MFPRCFLG	14	


//__________________	MIVT Codes	__________
#define	_MSMIVTOK	0
#define	_MSMIVTER	(-10)
#define	_MSMIVTST	256
#define	_MSMIVTDY	512
#define	_MSMIVTAL	768



/*__________________	Resource Strings _____*/
#define	_MSMSTTYP	'MST '
#define	_MSSTRTYP	'STR#'
#define	_MSPRCTYP	'PROC'
#define	_MSPRVTYP	'MST1'
#define	_MSCFGTYP	'MSTx'

/*__________________	TypeDefs	__________________*/
typedef	char		MVOpCode;
typedef	char		MVArgT;
#define	_MVARGDIM		5
typedef	struct
{
	MVOpCode	opCode;
	MVArgT		argT[_MVARGDIM];
}MenuVerb;
typedef	MenuVerb	ToggleFlag;
#define	_TFBITSZE	(sizeof(ToggleFlag)*8-1)

typedef struct
{
	MenuHandle		MH;
	long			sysRes;
	long			**MIVTH;
	long			procID[2];
	long			MIVTdefVal;
	long			MIVTnullVal;
//
	short			staticCount;
	short			allocCount;	
	short			beforeID;
	short			ttgStrID;
//
	ToggleFlag		TF;
	MenuVerb		MVT[_TFBITSZE+1];
}MenuStuff;
typedef MenuStuff		*MSPtr;
typedef MSPtr			*MSHdl;
#define	_MSFIXLEN		42

typedef struct
{	
	short			dbgFlg;
	short			relFlg;
	short			alrtID;
	short			errStrID;
	short			prgStrID;
	short			altErrStrID;
	short			altPrgStrID;
}MSConfig;

//____________	Externals	_____________
extern	MSHdl		MSGetMSH();
extern	MSConfig	MSInit();

/* _________________ Error String ID's ___________*/
#define	_MSERR01	1	/* MSH Invalid */
#define	_MSERR02	2	/* MH Invalid */
#define	_MSERR03	3	/* MIVTH Invalid */
#define	_MSERR04	4	/* PROC Hdl Invalid - item means PROC 1 or 2*/
#define	_MSERR05	5	/* PROC returns  0 - item means PROC 1 or 2 */
#define	_MSERR06	6	/* Set TOG/MEN without Expanded Range flag */
#define	_MSERR07	7	/* TxTg STR# Invalid */
#define	_MSERR08	8	/* Indx STR Invalid */
#define	_MSERR09	9	/* EX RG ONLY for NZEXRG */
#define	_MSERR10	10	/* PROC ID and MIVTfct= 0 */
#define	_MSERR11	11	/* UNDEFINED ERROR*/
#define	_MSERR12	12	/* PREVH invalid */
#define	_MSERR13	13	/* ResError <> 0 */
#define	_MSERR14	14	/* Def ArgT Parsing : one but not both first/last =0 */ 
#define	_MSERR15	15	/* Def ArgT Parsing : No PREV or NEXT line Group for ENBSET */ 
#define	_MSERR16	16	/* Def ArgT Parsing : rel parent not in [first,last] */ 
#define	_MSERR17	17	/* Dynamic Items : can't add/delete anymore items */ 
#define	_MSERR18	18	/* MSMake Validation : StaticCount > AllocCount  */ 
#define	_MSERR19	19	/* MSMake Validation : TogFlg[i]0, opCode[i] NORMAL or MENLIN  */ 
#define	_MSERR20	20	/* MSMake Validation : Unknown opCode  */ 
#define	_MSERR21	21	/* MSMake Validation : TogFlg[i]0, i > StaticCount  */ 
#define	_MSERR22	22	/* MSMake Validation : Handle NE allocCount */ 
#define	_MSERR23	23	/* MSSignal : Continue button */
#define	_MSERR24	24	/* Dynamic Items : TTGTOG & TTGSET not implemented */

/* _________________ ProgName ID's ___________*/
#define	_MSPRG01	1	/* MSMake */
#define	_MSPRG02	2	/* MSDispatch */
#define	_MSPRG03	3	/* MSDispatch1 */
#define	_MSPRG04	4	/* MSInsert */
#define	_MSPRG05	5	/* MSDispose */
#define	_MSPRG06	6	/* MSGetTog */
#define	_MSPRG07	7	/* MSGetMIVT */
#define	_MSPRG08	8	/* MSAdjTog */
#define	_MSPRG09	9	/* MSTogBit */
#define	_MSPRG10	10	/* MSAdjPREV */
#define	_MSPRG11	11	/* MSDispatch2 */
#define	_MSPRG12	12	/* MSInsMenuItem */
#define	_MSPRG13	13	/* MSDelMenuItem */
#define	_MSPRG14	14	/* MSShift */
#define	_MSPRG15	15	/* MSFindMIVT */
#define	_MSPRG16	16	/* MSCallProc */
#define	_MSPRG17	17	/* PROC Fct */
#define	_MSPRG18	18	/* MSSetMIVT */
#define	_MSPRG19	19	/* MSGetIndStr */
#define	_MSPRG20	20	/* MSValidation */
#define	_MSPRG21	21	/* Non-MS Function */

