(*******************************************************************
	
	Common.p
	
	Declarations for dynamic Transfer menu demo.
	
	(c) 1988, by Clifford Story & Attic Software
	
*******************************************************************)
	
unit Common;
	
(******************************************************************)

	interface
		
(******************************************************************)
	
	uses macintf;
	
(*******************************************************************
	
	Key codes:
		
*******************************************************************)
	
	const
	
		enterkey				=	3;
		backspace			=	8;
		tabkey				=	9;
		returnkey			=	13;
		clearkey				=	27;
		leftarrow			=	28;
		rightarrow			=	29;
		uparrow				=	30;
		downarrow			=	31;
		periodkey			=	46;
	
(*******************************************************************
	
	Dialog items:
		
*******************************************************************)
		
		themask				=	3;
		
(*******************************************************************
	
	Low-memory globals:
		
*******************************************************************)
	
		applscratch			=	$A78;
		bootdrive			=	$210;
		bootdisk				=	$B34;
		curappname			=	$910;
		curdirstore			=	$398;
		currenta5			=	$904;
		findername			=	$2E0;
		fsfcblen				=	$3F6;
		grayrgn				=	$9EE;
		iaznotify			=	$33C;
		mbarheight			=	$BAA;
		menuflash			=	$A24;
		resload				=	$A5E;
		rom85					=	$28E;
		sfsavedisk			=	$214;
		sysmap				=	$A58;
		windowlist			=	$9D6;
	
(*******************************************************************
	
	Program MDEF message:
		
*******************************************************************)
		
		msethandle			=	1001;
		
(*******************************************************************
	
	Program constants:
		
*******************************************************************)

		menunum				=	1001;
			aboutitem		=	1;
			atticitem		=	2;
			transitem		=	4;
			edititem			=	5;
			finderitem		=	7;
		
		messagedialog		=	1001;
		editdialog			=	1002;
			editlist			=	4;
			editdelete		=	5;
			editline			=	6;
		
		mdefnum				=	1001;
		ldefnum				=	1001;
		trnsnum				=	1001;
		
		procid				=	$54524E53;		{'TRNS'}
		
(*******************************************************************
	
	Standard types:
		
*******************************************************************)

	type
		
		logical				=	boolean;
		long					=	longint;
		
		shortpointer		=	^integer;
		longpointer			=	^long;

		QDrecord				=	record
			randseed			:	long;
			screenbits		:	bitmap;
			arrow				:	cursor;
			dkgray			:	pattern;
			ltgray			:	pattern;
			gray				:	pattern;
			black				:	pattern;
			white				:	pattern;
			theport			:	grafptr;
		end;
		QDpointer			=	^QDrecord;
	
(*******************************************************************
	
	Program types:
		
*******************************************************************)
		
		str27					=	string[27];
		str31					=	string[31];
		
		tline					=	record
			volume			:	str27;
			directory		:	long;
			name				:	str31;
		end;
		
		trecord				=	record
			count				:	integer;
			appl				:	array [1..100] of tline;
		end;
		tpointer				=	^trecord;
		thandle				=	^tpointer;
		
		grecord				=	record
			unitnumber		:	integer;
			resfactor		:	integer;
			menuheight		:	integer;
			themenu			:	menuhandle;
			menudata			:	thandle;
			menudisk			:	integer;
			menufile			:	integer;
			newappl			:	tline;
			choice			:	integer;
		end;
		gpointer				=	^grecord;
		ghandle				=	^gpointer;
		
		mixedblock			=	record
		case integer of
			0	:	(volblock	:	paramblockrec);
			1	:	(hfsblock	:	hparamblockrec);
			2	:	(dirblock	:	wdpbrec);
		end;

(******************************************************************)

	function QDglobals : QDpointer;
		
(******************************************************************)

	implementation
		
(******************************************************************)

	function QDglobals : QDpointer;
		
		var
			thepointer		:	longpointer;
		
		begin
			
			thepointer := longpointer(currenta5);
			thepointer := longpointer(thepointer^);
			QDglobals := QDpointer(long(thepointer^)
							- sizeof(QDrecord) + sizeof(grafptr));
		
		end;
	
(******************************************************************)
	
end.
	
(******************************************************************)
