(*******************************************************************
	
	types.pas
	---------
	
	(c) 1987, 1988 Attic Software
	
	Pascal declarations for Transfer
	
*******************************************************************)

unit types;

(******************************************************************)

	interface

(******************************************************************)

	uses macintf, hfs;

(******************************************************************)

	type
		
		logical				=	boolean;
		long					=	longint;
		
		shortpointer		=	^integer;
		longpointer			=	^long;

(*******************************************************************
	
	Program constants consist of (1) DA message types (most of which
	are not used in Transfer); (2) low-memory globals; and (3) resource
	ids.
	
*******************************************************************)

	const
		
		accEvent				=	64;
		accRun				=	65;
		accCursor			=	66;
		accMenu				=	67;
		accUndo				=	68;
		accCut				=	70;
		accCopy				=	71;
		accPaste				=	72;
		accClear				=	73;
		goodbyekiss			=	-1;
		
		curappname			=	$910;
		erik					=	$4552494B;
		findername			=	$2E0;
		iaznotify			=	$33C;
		sysmap				=	$A58;
			
		menunum				=	1001;
			aboutitem		=	1;
			builditem		=	2;
			finderitem		=	4;
		
		errordialog			=	1001;
		aboutdialog			=	1002;
		builddialog			=	1003;
		delaydialog			=	1004;
		
		packnum				=	1001;
		stringnum			=	1001;
		
		datastart			=	1000;
	
(*******************************************************************
	
	A deskrecord is simply an application's name and directory.  We
	need to know both of these to transfer to that application.
	
	An marray is an array of deskrecords, along with the array's
	size.
	
	Finally, a wrecord is the DA's  global data.  The last three
	fields (theEvent, thename and the varient parameter block)
	are just scratch areas, used by various routines as local
	variables.  Putting them here keeps them off the stack.
	
*******************************************************************)
	
	type
		
		deskrecord			=	record
			dirid				:	long;
			name				:	Str255;
		end;
		deskpointer			=	^deskrecord;
		deskhandle			=	^deskpointer;
		
		marray				=	record
			count				:	integer;
			data				:	array [0..1000] of deskhandle;
		end;
		arraypointer		=	^marray;
		arrayhandle			=	^arraypointer;
		
		wrecord				=	packed record
			theMenu			:	MenuHandle;			{   0	}
			resfactor		:	integer;				{   4	}
			sysdir			:	long;					{   6	}
			packaddr			:	Ptr;					{  10	}
			launchpath		:	long;					{  14	}
			launchaddr		:	long;					{  18	}
			iazaddr			:	long;					{  22	}
			theEvent			:	EventRecord;		{  26	}
			thename			:	Str255;				{  42	}
		case dummy	:	integer of					{ 298	}
			1					:	(infoblock	:	CInfoPBRec);
			2					:	(hblock		:	HParamBlockRec);
			3					:	(wdblock		:	WDPBRec);
		end;
		wpointer				=	^wrecord;

(******************************************************************)

	implementation

(******************************************************************)

	end.

(******************************************************************)
