/* Vaccination.c
  * by Mike Scanlin   12 March 88
  *
  * Remove the 'nVIR' virus from an application chosen by the user.
  */
  
#include	"QuickDraw.h"
#include	"ResourceMgr.h"
#include	"StdFilePkg.h"
#include	"FileMgr.h"

#define	NIL					0L
#define	reg					register

#define	REPORT_STATUS_ALERT	129

#define	nVIR_CODE_256_SIZE	372

#define	nVIR2Bad				-10
#define	nVIR2NotFound			-11

void	RemoveResourceFromFile(long theType, int theID, int refNum);
int		Innoculate(Str255 *fileName, int vRef);
void	pStrCpy(char *p2, char *p1);
Boolean	ChooseFile(Str255 *fn, int *vRef);
void	main(void);

static SFReply	reply;
static int		applResFile;


/* RemoveResourceFromFile(theType, theID, refNum)
  *
  * This will remove the resource of type theType and ID theID from the open resource file
  * whose refNum is refNum.
  */
void RemoveResourceFromFile(theType, theID, refNum)
long	theType;
int		theID;
int		refNum;
{
	reg Handle		theResource;
	
	if ((theResource = GetResource(theType, theID)) && (HomeResFile(theResource) == refNum))
		RmveResource(theResource);
}


/* Innoculate(fileName, vRef)
  *
  * This removes the 'nVIR' virus from *fileName in directory vRef.
  */
int Innoculate(fileName, vRef)
reg Str255	*fileName;
int			vRef;
{
	reg Handle		oldCODE, currentCODE;
	reg int			i, refNum, returnVal;
	ParamBlockRec	pb;
	
	/* init the ParamBlockRec to all zeros */
	asm {
			lea		pb,A0
			move.l	#sizeof(ParamBlockRec),D0
			subq.l	#1,D0
			
		@1	clr.b	(A0)+
			dbra	D0,@1
	}
	
	/* set the current working directory */
	pb.ioParam.ioVRefNum = vRef;
	PBHSetVol(&pb, FALSE);
	
	refNum = OpenResFile(fileName);
		
	if ((oldCODE = GetResource('nVIR', 2)) && (HomeResFile(oldCODE) == refNum)) {
		if (GetHandleSize(oldCODE) != 8)
			/* if 'nVIR' 2 isn't 8 bytes, then something isn't right. */
			returnVal = nVIR2Bad;
		else {
			if ((currentCODE = GetResource('CODE', 0)) && (HomeResFile(currentCODE) == refNum)) {
				asm {
						MOVE.L	oldCODE, A1
						MOVE.L	(A1),A1
						MOVE.L	currentCODE, A0
						MOVE.L	(A0),A0
						ADDA	#16, A0
						MOVE.L	(A1)+, (A0)+
						MOVE.L	(A1), (A0)
				}
				ChangedResource(currentCODE);
			}
			
			/* kill the 'nVIR' resources */
			for (i = 0; i <= 7; i++)
				RemoveResourceFromFile('nVIR', i, refNum);

			/* kill the extra 'CODE' resource that this virus adds 
			  * (only if it has the size of nVIR_CODE_256_SIZE) */
			if ((currentCODE = GetResource('CODE', 256)) &&
				(GetHandleSize(currentCODE) == nVIR_CODE_256_SIZE) &&
				(HomeResFile(currentCODE) == refNum))
					RmveResource(currentCODE);
							
			returnVal = noErr;
		}
	}
	else
		returnVal = nVIR2NotFound;
	
	if (refNum != applResFile)
		CloseResFile(refNum);
	
	return(returnVal);
}


/* pStrCpy(p2, p1)
  *
  * Copy the pascal string at *p1 to *p2.
  */
void pStrCpy(p2, p1)
reg char	*p2, *p1;
{
	reg int	len;
	
	len = *p2++ = *p1++;
	while (--len >= 0) 
		*p2++ = *p1++;
}


/* ChooseFile(fn, vRef)
  *
  * Use SFGetFile() to get the name of an application from the user. Return the directory
  * of the chosen file in *vRef. Return FALSE if the user clicked Cancel, TRUE if they clicked
  * Open.
  *
  * Thanks to Chris Borton for this routine.
  */
Boolean ChooseFile(fn, vRef)
Str255	*fn;
int		*vRef;
{
	SFTypeList	myTypes;
	static Point	SFGwhere = { 90, 82 };
	
	myTypes[0] = 'APPL';
	myTypes[1] = 'FNDR';
	myTypes[2] = 'dahd';
	
	SFGetFile(SFGwhere, NIL, 0L, 3, myTypes, 0L, &reply);
	if (reply.good) {
		pStrCpy((char *)fn , (char *)reply.fName);
		*vRef = reply.vRefNum;
		return(TRUE);
	}
	else
		return(FALSE);
}


void main() {
	
	Str255	fileName;
	int		vRef;
	
	/* save the application's resource file refNum */
	applResFile = CurMap;
	
	InitGraf(&thePort);
	InitFonts();
	InitWindows();
	InitMenus();
	InitDialogs(0L);
	InitCursor();

	/* keep choosing files until the user hits Cancel */
	while (ChooseFile(&fileName, &vRef)) {
		switch (Innoculate(&fileName, vRef)) {
		case 	nVIR2Bad:
			ParamText(&fileName, "\pResource 'nVIR' 2 is not 8 bytes long. File cannot be repaired.", NIL, NIL);
			break;
		case nVIR2NotFound:
			ParamText(&fileName, "\pResource 'nVIR' 2 not found. File is not infected or cannot be repaired.", NIL, NIL);
			break;
		default:
			ParamText(&fileName, "\pVirus successfully removed.", NIL, NIL);
		}
		
		/* show the result of the attempted removal */
		Alert(REPORT_STATUS_ALERT, NIL);
	}
}
